#!/usr/bin/bash

set -e

PATH_OLD=$PATH
DATADIR=/mnt/pgdata/data-messages

function build_index {

        run=$1
        workers=$2
        branch=$3
        type=$4
        index=$5

	psql test -c 'checkpoint'
        psql test -c 'select pg_stat_statements_reset()'

        psql test > timing.log <<EOF
set log_temp_files = '64kB';
set maintenance_work_mem = '256MB';
set min_parallel_table_scan_size = '64kB';
set max_parallel_maintenance_workers = $workers;
set work_mem = '32MB';
CREATE INDEX idx ON $index;
DROP INDEX idx;
EOF

        data=$(psql test -t -A -c "select * from pg_stat_statements where query like 'CREATE INDEX %'")

        echo "$run|$workers|$branch|$type|$index|$data" >> results.csv

}

#for r in $(seq 1 5); do
for r in 1; do

	for w in 7 5 3 2 1 0; do

		for b in gin-0010 master gin-0009 gin-0005 gin-0003 gin-0007 gin-0001 gin-0002 gin-0004 gin-0006 gin-0008; do
		#for b in gin-0010; do

			IFS=' ' read -r -a array <<< "$line"

			PATH=/home/tomas/builds/pg-$b/bin:$PATH_OLD

			pg_ctl -D $DATADIR -l pg.log stop || true
			pg_ctl -D $DATADIR -l pg.log start

			build_index $r $w $b 'trgm' 'messages using gin (msg_body gin_trgm_ops)'
			build_index $r $w $b 'tsvector' 'messages using gin (msg_body_tsvector)'
			build_index $r $w $b 'jsonb' 'messages using gin (msg_headers)'
			build_index $r $w $b 'jsonb_hash' 'messages using gin (msg_headers jsonb_path_ops)'

		done

	done

done
